"""Exports storage class for bitmap images."""
import Image
import ImageTk
import Tkinter

class Bitmap:
    """Bitmap stores Tkinter id for the image displayable on Tkinter canvas.
    Game background is of class Bitmap. All characters use Bitmap to
    draw and place their visual presentation on the canvas."""
    def __init__(self, canvas, imgFile):
        self.pos = complex(0,0)
        self.canvas = canvas
        img = Image.open(imgFile)
        self.size = img.size
        self.picture = ImageTk.PhotoImage(img)
        self.id = self.canvas.create_image(0, 0, anchor=Tkinter.NW, image = self.picture)

