g = self.owner

# "geometry" and inter-character collision:
for m in g.members:
    #print "collision update, n messages = ", len(m.outBox)
    for msg in m.outBox:
        if (msg.type=="desiredTranslation"):
            currPos = msg.paramByName("currPos")
            delta = msg.paramByName("delta")
            newPos = currPos + delta
            
            # quick test: repulsion between characters
            repulsion = 0+0j
            for m1 in g.members:
                if m==m1: continue
                direction = newPos - m1.currPos
                dist = abs(direction)+0.001
                if dist<25:
                    repulsion += (direction * 25.0/dist) - direction
            
            newPos += repulsion
            delta = newPos - currPos

            if abs(delta)<1.0:
                delta = msg.paramByName("delta") #use original delta for turn
                delta = complex(delta.imag,-delta.real)
                newPos = currPos + delta
            
            #check if the new location is ok. If it's not ok, then modify the translation
            #and send back new translation parameters.
            for obst in g.obstacles:
                if (newPos.real > obst[0].real and newPos.real < obst[1].real 
                and newPos.imag > obst[0].imag and newPos.imag < obst[1].imag):
                    #push out of the obstacle
                    dleft = newPos.real - obst[0].real
                    dright = obst[1].real - newPos.real
                    dtop = newPos.imag - obst[0].imag
                    dbottom = obst[1].imag - newPos.imag
                    #print dleft, dright, dtop, dbottom
                    if dleft<=dright and dleft<=dtop and dleft<=dbottom:
                        newPos = complex(obst[0].real, newPos.imag)
                    elif dright<=dleft and dright<=dtop and dright<=dbottom:
                        newPos = complex(obst[1].real, newPos.imag)
                    elif dtop<=dleft and dtop<=dright and dtop<=dbottom:
                        newPos = complex(newPos.real,obst[0].imag)
                    elif dbottom <= dleft and dbottom <= dright and dbottom <=dtop: 
                        newPos = complex(newPos.real,obst[1].imag)
            newDelta = newPos - currPos
            m.sendCommand("resolvedTranslation", paramsDict={"correctedDelta":newDelta})
    

    

