import Tkinter
import Pmw

class ObjectBrowser:
    def __init__(self,root,game):
        self.root = root
        self.game = game
        self.buildView()
        self.objectBoxes = {}
        self.layerStart = [1]
        
    def buildView(self):
        self.canvas = Pmw.ScrolledCanvas(self.root,borderframe = 1,canvasmargin=10)
        self.canvas.pack(side=Tkinter.TOP, fill=Tkinter.BOTH, expand=Tkinter.YES)
    
    def collectMembers(self,depth,collective):
        try:
            test = collective.members[0]
        except:
            return
        i = 0
        if (len(self.layerStart)-1<depth):
            self.layerStart.append(0)
        else:
            i = self.layerStart[depth]
        for m in collective.members:
            if (self.objectBoxes.has_key(m)):
                pass
            else:    
                self.objectBoxes[m] = [depth,i]
                i += 1
                self.layerStart[depth] += 1
                self.collectMembers(depth+1,m)
    
    def rescaleLayers(self):
        maxPopulation = 0
        for layer in self.layerStart:
            if (layer>maxPopulation):
                maxPopulation = layer
        i = 0        
        for layer in self.layerStart:
            #~ newStart = (maxPopulation - layer)/2.0
            #~ self.layerStart[i] = newStart
            newScale = maxPopulation/(layer+0.5)
            self.layerStart[i] = newScale
            i += 1
    
    def populateView(self):
        #collect object positions
        if (self.game!=None):
            self.objectBoxes[self.game]=[0,0]
            self.collectMembers(1,self.game)
        #optimize arrangment here
        self.rescaleLayers()
        #draw objects    
        canvas = self.canvas.component("canvas")
        for obj in self.objectBoxes.keys():
            p = self.objectBoxes[obj][0]
            d = self.objectBoxes[obj][1]
            frm = Tkinter.Frame(canvas,relief=Tkinter.SUNKEN,borderwidth=1)
            Tkinter.Button(frm,text=obj.name).pack()
            x0 = self.posOnCanvas(p,d)[0]
            y0 = self.posOnCanvas(p,d)[1]
            canvas.create_window(x0,y0,window=frm,anchor=Tkinter.CENTER)
            #draw lines:
            try:
                test = obj.members[0]
            except:
                continue
            for m in obj.members:
                pm = self.objectBoxes[m][0]
                dm = self.objectBoxes[m][1]
                x1 = self.posOnCanvas(pm,dm)[0]
                y1 = self.posOnCanvas(pm,dm)[1]
                self.canvas.create_line(x0,y0,x1,y1)                
        self.canvas.resizescrollregion()
        
    def setGame(self,game):
        self.game = game
        self.canvas.destroy()
        self.buildView()
        self.populateView()

    def posOnCanvas(self,layerId,indexInLayer):
        #~ shift = self.layerStart[layerId]
        #~ return (50+layerId*210,30+50*(indexInLayer+shift))
        scale = self.layerStart[layerId]
        return (50+layerId*210,30+scale*50*(indexInLayer+0.5))
