"""OSM package separates the core of the AI engine from the rest of the
code.

OSM is based on the metaphor of 'Bureaucratic Dictatorship'. 'Brazil' is a short
name for the metaphor of 'Bureaucratic Dictatorship'.

The name Brazil reflects that no Agent in the adopted architecture can have any
sort of 'free will'. All Agents are controlled by Collectives and Dispatchers in
an Orwellian way.

The main implications from the metaphor are:

--All objects are organized in a hierarchy. The hierarchy is based on how 
the information flows between objects. Objects can send each other messages.
Messages can go only up (reports) or down (commands) in the hierarchy.
There is no communication between same-level objects.

--The hierarchy sets restrictions on the ownership of objects. There are two
types of objects 'in command': Dispatchers and Collectives. Collective is an 
owner responsible for creating its subordinate objects (members) and for tracking 
their life cycle. Dispatcher, while it can send commands to its members like 
Collective, does not own them.

--At the lowest level of the hierarchy is Agent. Agents don't own other 
objects. They can send reports, receive and execute commands. But Agents 
don't send commands to other objects.

--At the very top is an object of type Collective which is responsible for
creating and managing all other Agents, Collectives and Dispatchers in 
the application.

The main advantage of the Orwellian approach is that the system is completely 
deterministic and allows to track down or assign any behavior to a particular 
layer. The main criterion in creating layers is simple: when objects need any 
sort of cooperation, they have to be members of some Dispatcher or Collective 
that will implement their cooperation. Then the responsibilities and communication 
of objects are defined by simple rules which are easy to implemenet on each 
layer as a built-in object's code or as external scripts."""

import fsm
import agent
import collective
import message
import script
