"""A bunch of handy utility functions for dealing with xml files."""

import xml.dom.minidom

def appendNamedText(DOM,parent,name,text):
    """Creates a named node under the parent with text as a child text node."""
    nameElement = DOM.createElement(name)
    dataElement = DOM.createTextNode(text)
    nameElement.appendChild(dataElement)
    parent.appendChild(nameElement)

def extractData(node):
    """Finds text under a node and returns it if found, otherwise returns None."""
    for n in node.childNodes:
        if (n.nodeType==xml.dom.minidom.Node.TEXT_NODE):
            #print "n.data=", n.data
            return n.data
    return None

